/*  zipit.cmd */
/* zip one partition.  Old zipit procedure from mobu.cmd */
arg px to full .

if px='' then do
   say 'usage is zipit driveletter targetdirforzipfile type (FD or I)'
   say 'target dir must end with a \'
   say ' intended to be called from a wrapper cmd file'
   exit
   end
   
   say 'zipit called with args' px to full

call RxFuncAdd 'SysLoadFuncs','RexxUtil','SysLoadFuncs'
call SysLoadFuncs

here=directory()

hered=here||"\"

logfile=hered||'zbu.log'
tfile=hered||"tmp\zipbu.tmp"
compress = '8'
xfile='-x@'||hered||'exclude-'||px

say 'Backing up' px
if full <> 'F' then do
   call SysFileDelete tfile

   if full='I' then do
      targatt='-****'
      say 'getting files with A bits; resetting A bits'
      end
    else do
      targatt='*****'
      say 'getting files with A bits'
      end

   x=SysFileTree(px||':\*.*',"stem",'SF','+****',targatt)
   totalsize=0

   do i=1 to stem.0
      parse value stem.i WITH . . filsiz . filnam
      filnam=STRIP(filnam)
   /*    say filnam */
      totalsize=totalsize+filsiz
      call lineout tfile,filnam
      end
   call lineout tfile
   say stem.0 'files totalling' totalsize 'bytes'
   end /* -I or -D a bit processing */

   /* avoid problems if we are currently in a fat directory */
xx=directory(px||":\")
    mmdd=right(date('S'),4)
if full=F then do
    zipfile=to||px||mmdd||'ALL.ZIP'
    'zip -rS'||compress zipfile '.'  xfile
    end
    else do
   zipfile=to||px||"-"||full||mmdd||".ZIP"
   'zip -rS'||compress zipfile '. -i@'||tfile   xfile
    end
xx=directory(here)

x= SysFileTree(zipfile,'ft')
if x>0 then say 'SysFileTree failed'
parse var ft.1 x x siz x
say 'zipfile size:' siz

splitted=''
/* zipsplit 


if siz>690000000 then do
   'echo SPLITLOG >t:zipsplit.log'
   'echo SPLITerr >t:zipsplite.log'
   call lineout logfile,'splitting: directory for zip file and zipsplit' to
   tox=left(to,length(to)-1)
   x=directory(tox)
   call lineout logfile,'Just before zipsplit: Current dir is' directory()
   'm:\os2progs\zipsplit -s -n 690000000' zipfile  '2>>t:zipsplite.log >>t:zipsplit.log'
   'RXQUEUE /CLEAR'
   'dir *.zip | RXQUEUE'
   if queued()>1 then call sysfiledelete zipfile
   'dir *.zip | RXQUEUE'
   /* call sysfiledelete zipfile  */
   splitted="split"
   'type t:zipsplit.log >>'||logfile
   'type t:zipsplite.log >>'||logfile
    call sysfiledelete "t:zipsplit.log"
    call sysfiledelete "t:zipsplite.log"
   end

end of split */


outlin=date('S') '  ' time('N') '  ' zipfile siz splitted
if full <>F then outlin = outlin full stem.0 'files'
say outlin

call lineout logfile,outlin
call lineout logfile
if full='F' then do
   say 'resetting A bits for files:'
   x=SysFileTree(px||':\*.*',"stem",'SF','+****','-****')
   end
