/* zbu.cmd (was bucontrol.cmd */

call RxFuncAdd 'SysLoadFuncs','RexxUtil','SysLoadFuncs'
call SysLoadFuncs


arg phase  partx .

/***   system specific settings  - this is for T23 ***/
p1part="CDEM"   /*   partition to be backed up in phase 1 */
p2part='FGH'  /* partitions to be backed up in phase 2 */
hered="M:\backer"
here=hered||'\'
                   
flagfile=here||'zbuflag'
logfile=here||"zbu.log"

mbudiag=here||"mbudiag.log"
   
                           


/* type codes   full=F   Diff=D  incremental = I(letter eye)  */
/* type.='D'   */

type.='F'
typx="F"


/*  P is fat32;  Q is HPFS  */
to.C='p:\Cbu\'
to.D='p:\Dbu\'
to.E='p:\Ebu\'

to.F='q:\Fbu\'
to.G='q:\Gbu\'
to.H='q:\Hbu\'
to.M='q:\Mbu\'

outlin=date() time() 'ZBU phase' phase 
if phase<>'' then call lineout logfile,outlin       

if phase='1' then do /* called from ecs cron job.  Backup p1 parts  */ 
   outlin="  Phase 1" date() time() 'type' typx
   call lineout logfile,outlin 
      
/*  3.  call zipit   */
part=p1part
do while length(PART)>0
   px=left(part,1)
   part=substr(part,2)
    if typx='F' then do
       /* clear out old one */
       'del' to.px||'*.* <yfile'
       end        
    
    xyz=directory(hered)
    say ' calling zipit ' px to.px typx
    say 'sleeping 8 sec'
    call syssleep 8
                                                 
    call "zipit.cmd" px to.px typx
    xyz=directory(hered)
    end

    

      
    say 'about to do shutdown stuff and setboot'
    
                                      
    junk=directory(hered)
    call lineout flagfile,date() time()
    call lineout flagfile
    call lineout logfile
    call syssleep 10
return                        /* temp  */
    call "zbu-closep1.cmd"    
    'exit'
    end   /* do phase1 */
    
if phase=2 then do    

part=p2part

if partx<>'' then part=partx

                                      
/* from startup folder for maint part */

/* 1.  look for flag file.  If not there, quit  */
z=stream(flagfile,'C','QUERY EXISTS')
if z='' then do
   say 'no flag file present'
   exit
   end


/* 2a. Warn.  */
   say 'About to initiate zip backup of ecs partitions' part
   say 'Backup cycle' cycle 'subcycle' subcycle 'type' type.subcycle
   say 'You have 10 secs to break out of this!'
   call syssleep 12
      
   outlin="  Phase 2" date() time() 
   call lineout logfile,outlin 
      
/*  3.  call zipit   */

do while length(PART)>0
   px=left(part,1)
   part=substr(part,2)
    if typx='F' then do
       /* clear out old one */
       'del' to.px||'*.* <yfile'
       end        
    
    xyz=directory(hered)
    say ' calling zipit ' px to.px typx
    say 'sleeping 8 sec'
    call syssleep 8
                                                 
    call "zipit.cmd" px to.px typx
    xyz=directory(hered)
    end  /* length(part)>0  */


/*4.  clear flagfile  */
call sysfiledelete flagfile

   
   call lineout logfile,'Finished' date() time() 
   call lineout logfile,' ' 
   call lineout logfile
   

say 'pausing 10 sec before reboot to break out if you want'
call syssleep 10
      
/*6. setboot /ibd:d  */
say 'issuing zbu-closep2.cmd (setboot or whatever)'
/*  exit  */
xyz=directory(hered)
    call "zbu-closep2.cmd"    
'exit'
end /* arg = 2 */

say 'zbu.cmd is not intended for casual execution.  Nothing happening'
say 'manual usage:  zbu phase (1 or 2) [partlist - phase 2 only]'
