/* zbu.cmd (was bucontrol.cmd */

call RxFuncAdd 'SysLoadFuncs','RexxUtil','SysLoadFuncs'
call SysLoadFuncs


arg phase  partx .


hered="M:\backer"
icedir="h:\mr2ice"
here=hered||'\'
cymax=3
subcymax=5                           
flagfile=here||'zbuflag'
cyclefile=here||'zipcy.fil'
logfile=here||"zbu.log"

mbudiag=here||"mbudiag.log"
   
                           


/* type codes (indexed by subcycle)  full=F   Diff=D  incremental = I(letter eye)  */
type.='D'

type.1='F'



/*  2.  determine cycle, subcycle  */
cylin=linein(cyclefile)
parse var cylin cycle subcycle
call stream cyclefile,'C','CLOSE'

       
       
to.D='j:\Dbu\'||cycle||"\"
to.F='J:\Fbu\'||cycle||"\" 
to.H='J:\Hbu\'||cycle||"\" 
to.E='J:\Ebu\'||cycle||"\"

to.G='K:\Gbu\'||cycle||"\"  
to.M='K:\Mbu\'||cycle||"\"  

/*  fat32 stuff
to.c='L:\Cbu\'||cycle||"\"  
to.D='L:\Dbu\'||cycle||"\"  */


loglin=date() time() 'ZBU phase' phase 'cycle' cycle 'subcycle' subcycle 

if phase='1' then do /* called from ecs cron job.  Backup M then */ 
   call lineout logfile,loglin       
   part='M'    /* maybe fat32 also here */
do while length(PART)>0
   px=left(part,1)
   part=substr(part,2)
    
    if type.subcycle='F' then do
       diagoutlin='del' to.px||'*.zip '
       call lineout logfile,diagoutlin
       end        

    say ' calling zipit ' px to.px type.subcycle
    outlin= ' calling zipit ' px to.px type.subcycle
    call lineout logfile,outlin 
    say 'sleeping 6 sec'
    call syssleep 6
    
    xyz=directory(hered)
                                                 
    call "zipit.cmd" px to.px type.subcycle
end   /* looping on length of part  */
      
    say 'about to shutdown ice, save T disk, and and setboot'
    
    call syssleep 10
    junk=directory(icedir)
    'h:\mr2ice\mr2iu /`  '
    
    junk=directory(here)
    call lineout flagfile,date() time()
    call lineout flagfile
    call lineout logfile
    
    'del h:\tbu\tbu.zip'
    xyz=directory('T:\')
    'zip -rS8 h:\tbu\tbu.zip .' 
    'setboot /IBD:M'
    'exit'
    end
    
if phase=2 then do    

part='EFGH'  /* maybe  e  later  */

if partx<>'' then part=partx
do while length(PART)>0
   px=left(part,1)
   part=substr(part,2)

                                      
/* from startup folder for maint part */

/* 1.  look for flag file.  If not there, quit  */
z=stream(flagfile,'C','QUERY EXISTS')
if z='' then do
   say 'no flag file present'
   call syssleep 3
   '@exit'
   exit
   end
   call lineout logfile,loglin       

/* 2a. Warn.  */
   say 'About to initiate zip backup of ecs partitions' part
   say 'Backup cycle' cycle 'subcycle' subcycle 'type' type.subcycle
   say 'You have 10 secs to break out of this!'
   call syssleep 12
      
   outlin="  Phase 2" date() time() 'cycle' cycle 'subcycle' subcycle 'type' type.subcycle    
   call lineout logfile,outlin 
      
/*  3.  call zipit   */

    if type.subcycle='F' then do
       /* clear out old one */
       'del' to.px||'*.* <yfile'
       end        
    
    xyz=directory(hered)
    say ' calling zipit ' px to.px type.subcycle
    say 'sleeping 8 sec'
    call syssleep 8
                                                 
    call "zipit.cmd" px to.px type.subcycle
    xyz=directory(hered)
    end


/*4.  clear flagfile  */
call sysfiledelete flagfile

/*5.  if SA, increment cycle  */

if subcycle=subcymax then do
   cycle=cycle+1
   subcycle=1
   if cycle=cymax+1 then cycle=1
   end
   else do
   subcycle=subcycle+1
   end
   
   call sysfiledelete cyclefile
   call lineout cyclefile,cycle subcycle
   call stream cyclefile,'C','CLOSE'
   
   call lineout logfile,'Finished' date() time() 'NEXT cycle' cycle 'subcycle' subcycle
   call lineout logfile,' ' 
   call lineout logfile
   

say 'pausing 10 sec before reboot to break out if you want'
call syssleep 10
      
/*6. setboot /ibd:f  */
say 'issuing setboot'
/*  exit  */
'setboot /IBD:F'
'exit'
end /* arg = 2 */

say 'zbu.cmd is not intended for casual execution.  Nothing happening'
say 'manual usage:  zbu phase (1 or 2) [partlist - phase 2 only]'
